GearEvaluator.Broker = {}

function GearEvaluator.Broker:BuildTooltip(tt)
  tt:AddLine("Current Scores:")

  if (GearEvaluator.db.profile.evaluators) then
    for k in pairs(GearEvaluator.db.profile.evaluators) do
      tt:AddDoubleLine(k, GearEvaluator.scores[k] or GearEvaluator.errors[k])
    end
  end

  tt:AddLine("Left-click to modify evaluators")
  tt:AddLine("Right-click to edit preferences")
end

function GearEvaluator.Broker:OnClick(frame, button)
  if (button == "RightButton") then
    InterfaceOptionsFrame_OpenToCategory(GearEvaluator.dialogs.main)
  else
    InterfaceOptionsFrame_OpenToCategory(GearEvaluator.dialogs.evaluators)
  end
end

function GearEvaluator.Broker:Init()
  self.LDB = LibStub("LibDataBroker-1.1", true)

  if (self.LDB) then
    self.dataobject = {
      type = "launcher",
      icon = "Interface\\icons\\Ability_Mage_StudentOfTheMind",
      OnClick = function(frame, button) GearEvaluator.Broker:OnClick(frame, button) end,
      OnTooltipShow = function(tt) GearEvaluator.Broker:BuildTooltip(tt) end
    }

    self.launcher = self.LDB:NewDataObject("GearEvaluator", self.dataobject)
  end
end
